#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>	// for usleep
#include <usb.h>	// libusb
#include "config.h"

// usb_hub.c
void open_usb(int vid, int pid);
void close_usb(void);
void pulse_port(int port);
void pulse_begin_port(int port);
void pulse_end_port(int port);
int read_port(int port);

// avr_isp.c
unsigned char programming_enable(void);
unsigned char read_signature_byte(unsigned char n);
void erase_chip(void);
void write_word(unsigned char offset, unsigned char first_byte, unsigned char second_byte);
void write_page(int addr);
int write_fuse_lsb(unsigned char fuse);
int write_fuse_msb(unsigned char fuse);
int write_fuse_ext(unsigned char fuse);
int write_lock_bits(unsigned char lock);

// ihex.c
int read_intel_hex(const char *filename);
int ihex_bytes_within_range(int begin, int end);
void ihex_get_data(int addr, int len, unsigned char *bytes);
int memory_is_blank(int addr, int block_size);

// misc.c
void delay(double sec);
void die(const char *, ...);

